#!/usr/bin/perl

# browse.cgi

# This is a cgi that will search the registry based on certain 
# inputs from the users.
#
# Copyright (C) 2002
# Ted Pedersen, University of Minnesota, Duluth
# tpederse@d.umn.edu
# Brian Rassier, University of Minnesota, Duluth
# rass0028@d.umn.edu
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#-----------------------------------------------------------------------------
#                              Start of program
#-----------------------------------------------------------------------------
use CGI;

#make a new cgi object to use
$cgi = new CGI();

#print a header for the cgi
print $cgi->header();

#print the top portion of the root html page
print <<EndHTML;
<html><head><title>Browse Registry of Latin American Researchers</title></head>
    <body BGCOLOR = "ffffff">
    <h2 align ="CENTER">Browse Registry of Latin American Researchers</h2>
<font color = ff0000><p align = center> Note: To update your entry, find your name and press the "update entry" option next to your information.</p></font><hr noshade>
EndHTML

    #used for seeing what types of input there are
    #search by letter, or by different fields.
    $inputflag = 0;

#finds the query string if a user selects a 
#letter link to find names beginning with that letter
if($ENV{'QUERY_STRING'}){

    #split the '&' in the query string
    @values = split(/&/,$ENV{'QUERY_STRING'});

    #split the = to find the letter
    foreach $i (@values){
	($varname, $mydata) = split(/=/,$i);
	$in{$varname} = $mydata;
    }
}
else{
    #if no querystring, undefine the querystring hash
    undef(%in);
}

#save the letter/member that was pressed
$search = $in{'az'};
$member = $in{'member'};

#clear out old alpha hash, which finds the number of names
#that begin with each letter.
%alpha = ();
    
#open registry to get in the data
open(INFP,"approvedadd/registry.txt") or dienice("Couldn't open registry.txt: $! \n");

#lock the file in case of multiple users
flock(INFP,2);

#move to the beginning of the file
seek(INFP,0,0);

#store the data in @data
@data = <INFP>;

#close file
close(INFP);

#if data is found
if(@data){
    #go through each line of data
    foreach $i (@data){
	#remove newline
	chomp($i);

	#split the information
	($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date) = split(/\|/, $i);

	#store the file based on last name into the HashOfArrays.
	#HashOfArrays is a hash of the people based on last name.
	#This takes care of the issue of two people having the same last name.

	#if the hash already has this last name, add another array to it
	if($HashOfArrays{$last_name}){
	    my @temp = @{$HashOfArrays{$last_name}};
	    push @temp,$i;
	    $HashOfArrays{$last_name} = \@temp;
	}
	#else, add a new array to a new hash
	else{
	    my @temp = ();
	    push @temp, $i;
	    $HashOfArrays{$last_name} = \@temp;
	}

	#make another hash, based on member numbers
	$HashOfNums{$num} = $i;

	#remove underscores from the values
	$country =~ s/_/ /g;
	$origin_country =~ s/_/ /g;
	
    }
}

#find the number of names that start with each letter
find_namelinks();

#if full entry was pressed, this finds the member number and prints the member's full entry
if($member){
    #if full entry was pressed, find the entry and print it
    if($in{'search'} eq "print"){
	findentry($in{'member'});
    }
}

#does the letter search if no other input was given besides the letter link that was clicked
if($search){
    #if a letter was pressed, print names with that letter
    if($in{'search'} eq "az"){
	print_az($search);
    }
}

#if no other input was given, print the search fields and all the entries
if(!($member || $search)){
    print_top();
    print "<a href= registry.cgi>Back Home</a><br><br>";
    printall();
}

#print the ending html page
print "</body></html>";  

#this function prints the top of the search page, with the search options and fields
sub print_top{

#print informational label
print "Browse by Last Names:";

#call the function that prints the links for each letter
print_namelinks();

}


#this function prints the smaller version of the entries
sub print_small{
    #get the entry that was passed in
    my $entry = shift;

    #split the information ($entry)
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $entry);

    #correct the homepage syntax (adds http:// if necessary)
    $link = $homepage;
    $link="http://".$link  unless $link =~ /\/\/|none|empty/gi;

    #this large print statement prints the information of the given user, in small format
    if($homepage eq "none" || $homepage eq "empty"|| $homepage eq ""){
	print "<tr><td>$last_name, $first_name</td>";
    }
    else{
	print "<tr><td><a href=$link>$last_name, $first_name</a></td>";
    }
    print "<td>$country</td>";
    
    #make spaces underscores
    $last_name =~ s/ /_/g;
    $first_name =~ s/ /_/g;

    #print the links on the the page for full entry & update entry
    print qq'
        <td>[<a href= "browse.cgi?search=print&member=$num">Full Entry</a>] 
    	[<a href= "update.cgi?member=$num">Update Entry</a>] </td></tr>
';
}

#this function finds the entry that matches last name, first name, and email, and prints the full entry
sub findentry{
    #get the member number passed in
    my $mem = shift;

    #Send the print function the entry for that member
    print_visitor($HashOfNums{$mem});

    #print the back link on the bottom of the page
    print "<br><a href = browse.cgi>Back to Browse</a>";
		
}


#This function is used to print out a visitor's information if a search gets results
sub print_visitor{
    #get the entry that was passed in
    my $entry = shift;

    #split the information in $entry
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $entry);

    #correct the homepage syntax (adds http:// if necessary)
    if($homepage ne ""){
	$link = $homepage;
	$link="http://".$link  unless $link =~ /\/\/|none|empty/gi;
    }
    if($homepage2 ne ""){
	$link2 = $homepage2;
	$link2="http://".$link2  unless $link2 =~ /\/\/|none|empty/gi;
    }


    #this large print statement prints the information of the given user 
    print <<EndHTML;
    <table border = 10 noshade>
      <tr bgcolor = "ffff00"><td>
      Name:
	</td><td>$last_name, $first_name
	</td></tr>
	<tr><td>
      Job title/position::
	</td><td>
EndHTML
if($status =~ /^Student/){
    ($temp1, $temp2, $temp3) = split (/%%%/,$status);
     print "Student</td></tr><tr><td>Student Advisor/Supervisor:</td><td>$temp2</td></tr><tr><td>";
     print "Advisor/Supervisor's Email:</td><td><a href = mailto:$temp3>$temp3</a></td></tr>";
 }
     else{
	 $status =~ s/%%%/:/g;
	 print "$status </td></tr>";
     }
     print <<EndHTML;
	<tr><td>
	Organization:  
	</td><td>$affiliation
	</td></tr>
	<tr><td>
	Department:  
	</td><td>$department
	</td></tr>
	<tr><td>
	Address line 1:
	</td><td>$address
	</td></tr>
	<tr><td>
	Address line 2:
	</td><td>
EndHTML
if($address2 eq ""){
    print "none";
}
    else{
	print "$address2";
    }
    print <<EndHTML;
	</td></tr>
	<tr><td>
	City:
	</td><td>$city
	</td></tr>
	<tr><td>
	State/Province:
	</td><td>$state
	</td></tr>
	<tr><td>
        Postal Code:
	</td><td>$postal_code
	</td></tr>
	<tr><td>
	Country of Residence: 
	</td><td>$country
	</td></tr>
	<tr><td>
EndHTML
	
#prints the homepage and email as a link, unless "none" or "empty" were given
if($homepage eq ""){
    print "Personal Homepage: </td><td>none</td></tr><tr><td>";
}
    else{
	print "Personal Homepage:</td><td>  <a href=$link>$link</a></td></tr><tr><td>";
    }

    if($homepage2 eq ""){
	print "Departmental/Group Homepage: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Departmental/Group Homepage: </td><td> <a href=$link2>$link2</a></td></tr><tr><td>";
    }

    if($email eq "none" || $email eq "empty"){
	print "Email: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Email:</td><td>  <a href = mailto:$email>$email</a></td></tr><tr><td>";
    }

    if($email2 eq "none" || $email2 eq "empty" || $email2 eq ""){
	print "Alternate Email: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Alternate Email:</td><td>  <a href = mailto:$email2>$email2</a></td></tr><tr><td>";
    }

    #change spaces to underscores
    $last_name =~ s/ /_/g;
    $first_name =~ s/ /_/g;

    #prints the end of the data (research interests and origin country)
    print <<EndHTML;
    Research Interests:
    </td><td> $research
	</td></tr>
	<tr><td>
	Country of Origin:
	</td><td>$origin_country</td></tr></table>
	<i>Last updated: $date</i><br>
	<a href= "update.cgi?member=$num">Update Entry</a><br><br>
	
EndHTML
}


#This function finds the number of last names that start with each letter
sub find_namelinks{

    #examine each entry (each hash of arrays, and each array per hash)
    foreach $name (sort keys %HashOfArrays){
	foreach (@{$HashOfArrays{$name}}) {
	
	#gets the last name into $temp
	my $temp = $name;
	
	#gets the first letter of the last name
	$temp =~ s/^([A-Za-z]).*/$1/g;
	
	#makes the letter upper-case so repeats don't happen with upper/lower case
	$temp = uc($temp);
	
	#increments the hash with that letter 
	$alpha{$temp}++;
    }
    }
}

#This function prints the links for the last names that start with each letter
sub print_namelinks{
    print "<pre>";
    
    #for each letter
    foreach ("A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"){
	
	#if there are no last names with this letter, make it 0 
	$alpha{$_} = 0 unless($alpha{$_});

	#print the link unless there are no names starting with this letter
	print "<a href=\"browse.cgi?search=az&az=$_\">$_ </a>($alpha{$_})" unless ($alpha{$_} == 0);
    }
    print "</pre>";
}

#this function will print all the entries
sub printall{
    print "<table border = 2><tr bgcolor = \"ffff00\"><td>Name</td><td>Country of Residence</td><td>Options</td></tr>";

    #for each entry, print the small version
    foreach $name (sort keys %HashOfArrays){
	foreach (@{$HashOfArrays{$name}}) {
	    print_small($_);
	}
    }

    #print the back link at the bottom of the page
    print "</table><br><a href= registry.cgi>Back Home</a>";
}

#This function prints all the last names that begin with a certain letter
sub print_az{

    #get the letter that was passed in
    my $search = shift;
    
    #keeps track of how many names were printed
    my $printcount = 0;
    
    #prints the top of the webpage with the search fields
    print_top();

    #goes through each name in the database
    foreach $name (sort keys %HashOfArrays){
	#gets the last name
	my $temp = $name;
	
	#finds the first letter of the last name
	$temp =~ s/^([A-Za-z]).*/$1/g;
	
	#makes the letter uppercase if it is not originally
	$temp = uc($temp);

	#print the person's information if the letters match
	if($temp eq $search){
	    foreach (@{$HashOfArrays{$name}}) {

		#print the table info on the first entry
		if($printcount == 0){
		    print "<table border = 2><tr bgcolor = \"ffff00\"><td>Name</td><td>Country of Residence</td><td>Options</td></tr>";
		}
		
		#print the small version
		print_small($_);

		#increment the print counter
		$printcount++;
	    }
	}
    }

    #prints "no hits" if there were no people found with that letter starting their last name
    if(!$printcount){
	print "<br>no hits<br><a href= registry.cgi>Back Home</a>";
    }
    else{
	print "</table><br><a href= registry.cgi>Back Home</a>";
    }

}


 


#function will print an error message
sub dienice{
    my($msg) = @_;
    print "<h2Error</h2>\n";
    print $msg;
    exit;
}
