#!/usr/bin/perl

# registry.cgi
#
# This is a cgi that runs the main registry.  It contains
# the forms and data-checking information, as well as
# the root page of the registry.
#
# Copyright (C) 2002
# Ted Pedersen, University of Minnesota, Duluth
# tpederse@d.umn.edu
# Brian Rassier, University of Minnesota, Duluth
# rass0028@d.umn.edu
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#-----------------------------------------------------------------------------
#                              Start of program
#-----------------------------------------------------------------------------

use CGI;

#Global vars, CGI is the global cgi, field names are the names of the form fields, select
#names are the names of the select box fields, mail is the address to email comments to
use vars qw($CGI,@FIELD_NAMES,@SELECT_NAMES,$MAIL);


#This sets up the global field names array.  It contains the required fields
#for the registry form.
@FIELD_NAMES = ("last_name", "first_name", "affiliation", "department",
                "address", "city", "state","postal_code", "email", "research");

#This sets up the global Select field names array.  It contains the required 
#select fields for the registry form.
@SELECT_NAMES = ("country", "origin_country", "status");

#make a new cgi to use (Globally)
$CGI = new CGI();

#set up a $MAIL variable, which is the email address of the administrator.
#This variable is changed with setup.pl when the program is first set up.
$MAIL = "tpederse\@umn.edu";


#THIS BLOCK OF IF STATEMENTS CONTROLS THE FLOW OF
#THE WHOLE PROGRAM. IT LOOKS AT WHAT INPUTS ARE COMING
#IN FROM USERS CLICKING ON VARIOUS BUTTONS, AND DECIDES
#WHERE TO GO FROM THERE.

#goes to the entry form if user clicks this button
if($CGI->param("submit_entry")){
    formentry($CGI);
}
#Goes to the comments form to give us feedback
elsif($CGI->param("submit_comments")){
    commentsform($CGI);
}
#goes to the data-checker if user submits their info
#also allows the user to check their info again before saveing
elsif($CGI->param("submit_check")){
    checkentry($CGI);
}
#goes to the data-checker if user submits their info
#Sends the comments if they pass the email check.
elsif($CGI->param("submit_check_comments")){
    checkcomments($CGI);
}
#saves the info if the user OK's it, after the program checks the info
elsif($CGI->param("submit_good")){
    saveinfo($CGI);
}
#goes back to the form if the user doesn't like their entry
elsif($CGI->param("submit_bad")){
    redoform($CGI);
}
#default goes to the root page with all the information and ability
#to enter the form area
else{
    rootpage($CGI);
}

#This function makes it's own html page.  It makes the root html
#page with introductory remarks, options to fill out the data form,
#fill out comments, search the registry, or related links
sub rootpage{
    #get the cgi passed in
    my $cgi = shift;

    #finds the search letter if a user clicked one
    my $search = shift;

    #print a header
    print $cgi->header();
   
    #This big print statement is the whole HTML page for the main page
    print <<EndHTML;
    <html><head><title>Registry of Latin American Researchers in Natural Language Processing and Computational Linguistics </title></head>
	<body BGCOLOR = "ffffff">
	<h2 align ="CENTER">Registry of Latin American Researchers in Natural Language Processing and Computational Linguistics</h2>

<form method = post>

<table CELLPADDING=10 CELLSPACING=1 BORDER=0 WIDTH=100%>
<tr><td valign="TOP" align=CENTER width=20% height=25 bgcolor=#B0C4DE>
</td><td valign="TOP" align=CENTER width=80% height=25 bgcolor=#B0C4DE>
</td>
</tr>
<tr>
<td VALIGN="TOP" ALIGN=CENTER WIDTH=20% HEIGHT=25 BGCOLOR=#B0C4DE>
<font SIZE=2>
<input type = "submit" name = "submit_entry" value = "Join the Registry"></form
><hr noshade>
<form method=post action="search.cgi">
<input type = "submit" name = "submit_search" value = "Search/Update"></form>
<hr noshade>
<form method=post action="browse.cgi">
<input type = "submit" name = "submit_browse" value = "Browse Registry"></form>
<hr noshade>

<form method=post>
<input type = "submit" name = "submit_comments" value = "Send Us Your Comments"></form>
</form>
</font>
</td>
<td VALIGN="TOP">

<!---------------------------------------------------------->
<!--THIS IS WHERE THE INTRODUCTION REMARKS ARE-->
<!--THIS IS THE ONLY PLACE TO CHANGE THEM, IF THE CONTENT-->
<!--NEEDS TO BE CHANGED-->
<!---------------------------------------------------------->


Welcome to the Registry of Latin American Researchers in Natural Language  
Processing and Computational Linguistics! <br><br>

The objective of the Registry is to provide a centralized source of   
information for and about students, professors, researchers, and   
practitioners in Natural Language Processing and Computational 
Linguistics who currently reside in Latin America. If this describes 
you, or if you are originally from Latin America but living 
elsewhere, please take a moment to register.<br><br>

The creation of the Registry is a part of the Latin American outreach 
activities of the North American chapter of the Association for  
Computational Linguistics 
(<A HREF="http://www.cs.cornell.edu/home/cardie/naacl/"> NAACL </a>). 
Our hope is that the Registry will help promote Natural Language  
Processing and Computational Linguistics research being carried out in 
Latin America. In addition, we want to encourage further colloboration  
among researchers within Latin America and with the rest of the world.
<br><br>

The Association for Computational Linguistics  
(<A HREF="http://www.aclweb.org"> ACL </a>) is THE  
international scientific and professional society for people working on  
problems involving natural language and computation. The ACL hopes to  
increase the level of participation in Latin America. Until there is a  
chapter in these areas, the North American chapter (NAACL)  invites and  
encourages your involvement. As of 2002, discounted memberships to the  
ACL are available to those  who reside in Latin America. You can find 
out more details at the ACL membership 
<A HREF="http://www.cs.columbia.edu/~radev/newacl/membership.html"> page.</a> <br><br>

The Registry needs your help! We would like to provide Spanish and 
Portuguese versions of these pages. If you would be willing to help us 
please let us know when you register. <br><br>




</td>
</tr></table>
<table CELLPADDING=10 CELLSPACING=1 BORDER=0 WIDTH=100%>
<tr>
<td VALIGN="CENTER" ALIGN=CENTER WIDTH=20% HEIGHT=20 BGCOLOR=#B0C4DE>
<font SIZE=4>
<b>Related links:</b><br></td>
<td VALIGN="Center" ALIGN=CENTER HEIGHT=20 BGCOLOR=#B0C4DE>
<font size=2><a HREF="http://www.aclweb.org/">Association for<br>Computational<br>Linguistics</a><br><br></td><td VALIGN="center" ALIGN=CENTER HEIGHT=20 BGCOLOR=#B0C4DE>
<font size = 2><a HREF="http://www.cs.cornell.edu/home/cardie/naacl/">North American<br>Chapter of the<br>Association for<br>Computational<br>Linguistics</a><br></td>
<td VALIGN="center" ALIGN=CENTER HEIGHT=20 BGCOLOR=#B0C4DE>
<font size=2><a HREF="http://acl.ldc.upenn.edu/">The ACL Anthology:<br>A Digital <br>Archive of<br>Research Papers<br>in Computational<br>Linguistics</a><br><br></td>

</font>
<td VALIGN="TOP">
</td></tr></table></body></html>
EndHTML


}

#This function will print out its own html page.  It will make the 
#data form that must be filled out.
sub formentry{
    #get the cgi that was passed in
    my $cgi = shift;

    #print header
    print $cgi->header();
    
    #this print statement will print out the whole html page for the data form
    print qq'
<html>
  <head>
    <title>Contact Information Form</title>
   
  <style type="text/css">
   .SpecialOption {
     font-weight: bold ;
   }
 </style>

</head>

<body bgcolor="#ffffff">

  <h2 align = "center">Contact Information Form</h2>

<p align = "center"><font color = 0000ff>Blue asterisks mark OPTIONAL fields.</font><br> Thank you for your time.</p>

<hr noshade>

<form method = "POST">
<font size = 2>
<table border = 0>
<tr><td>
    Job title/position 
   </td><td>
 <select name="status" size = "1">
 <option value="none">Choose One</option>
                     <option VALUE="Student">Student
                     <option VALUE="Professor">Professor
                     <option VALUE="Researcher">Researcher
                     <option VALUE="Other">Other
</select>
</td></tr>
 <tr><td>
  Last Name(s) 
   </td><td>
    <input type = "text" name = "last_name" size = "30" maxlength = "50" >

   </td></tr>
 <tr><td>
 First Name
  </td><td>
    <input type = "text" name = "first_name" size = "30" maxlength = "50" >
   </td></tr>
 <tr><td>
  Organization 
  </td><td>
    <input type = "text" name = "affiliation" size = "30" maxlength = "50">
   </td></tr>
 <tr><td>
 Department 
  </td><td>
   <input type = "text" name = "department" size = "30" maxlength = "50">
   </td></tr>
 <tr><td>
  Address line 1 
  </td><td>
    <input type = "text" name = "address" size = "50" maxlength = "100">
   </td></tr>
 <tr><td>
 Address line 2 (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "address2" size = "50" maxlength = "100">
   </td></tr>
 <tr><td>
   City 
  </td><td>
    <input type = "text" name = "city" size = "50" maxlength = "100">
   </td></tr>
  <tr><td>
   State/Province  
  </td><td>
    <input type = "text" name = "state" size = "50" maxlength = "100">
   </td></tr>
<tr><td>
  Postal Code 
  </td><td>
    <input type = "text" name = "postal_code" size = "30" maxlength = "30" >
 <tr><td>
  Country of Residence 
  </td><td>
    <select name="country" size = "1">
 <option value="none">Please choose a country</option>
';
    #prints the countries of Latin America for the selectbox
    printworld();

print qq'                                                   


</select>
   </td></tr>
 <tr><td>
  Personal Homepage (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "homepage" size = "50" maxlength = "50">
   </td></tr>
 <tr><td>
    Departmental/Group Homepage (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "homepage2" size = "50" maxlength = "50">
   </td></tr>
 <tr><td>
   Primary Email Address 
  </td><td>
    <input type = "text" name = "email" size = "50" maxlength = "50">
   </td></tr>
 <tr><td>
    Alternate email Address (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "email2" size = "50" maxlength = "50">
   </td></tr>
 <tr><td>
   Research Interests 
  </td><td>
    <textarea rows=3 cols=50 name="research" wrap="physical"></textarea>
   </td></tr>
 <tr><td>
   Country of Origin 
  </td><td>
   <select name="origin_country" size = "1">
 <option value="none">Please Choose a Country</option>
';
    #prints the countries of the world for the selectbox
    printworld();

print qq'

    </select>
   </td></tr>
<tr>
  <td colspan=2 align=right>
    <input type="submit" name = "submit_check" value="Submit Form">
    <input type="reset" value="Clear Form"><br><br>
    <a href= "registry.cgi">Back Home</a><i> (Data will not be saved)</i>
  </td></tr>
 </table>
</form>
</body>
</html>
';
}

#This function will print out its own html page.  It will make the 
#data form that must be filled out, and leave in the old responses.
sub redoform{
    #get the cgi that was passed in
    my $cgi = shift;

    #print a header
    print $cgi->header();
    
    #this print statement will print out the whole html page for the redo-form page
    print qq'
<html>
  <head>
    <title>Contact Information Form</title>
   
</head>

<body bgcolor="#ffffff">

  <h2 align = "center">Contact Information Form</h2>

<p align = "center"><font color = 0000ff>Blue asterisks mark OPTIONAL fields.</font><br> Thank you for your time.</p>

<hr noshade>

<form method = "POST">

';
    #this saves the variables from the past cgi so they
    #can be used in the forms as defaults
    my $st = $cgi->param('status');
    my $ln = $cgi->param('last_name');
    my $fn = $cgi->param('first_name');
    my $af = $cgi->param('affiliation');
    my $c = $cgi->param('city');
    my $state = $cgi->param('state');
    my $d = $cgi->param('department');
    my $cr = $cgi->param('country');
    my $co = $cgi->param('origin_country');
    my $h = $cgi->param('homepage');
    my $h2 = $cgi->param('homepage2');
    my $e = $cgi->param('email');
    my $e2 = $cgi->param('email2');
    my $p = $cgi->param('postal_code');
    my $r = $cgi->param('research');
    my $a = $cgi->param('address');
    my $a2 = $cgi->param('address2');

print qq'
<table border = 0>
<tr><td>
 Job title/position 
   </td><td>
 <select name="status" size = "1">
<option VALUE="$st">$st
 <option value="none">Choose One</option>
                     <option VALUE="Student">Student
                     <option VALUE="Professor">Professor
                     <option VALUE="Researcher">Researcher
                     <option VALUE="Other">Other
</select>
</td></tr>
 <tr><td>


 Last Name(s)
   </td><td>
    <input type = "text" name = "last_name" size = "30" maxlength = "50" value = "$ln">

   </td></tr>
 <tr><td>
   First Name 
  </td><td>
    <input type = "text" name = "first_name" size = "30" maxlength = "50" value = "$fn">
   </td></tr>
 <tr><td>
   Organization
  </td><td>
    <input type = "text" name = "affiliation" size = "30" maxlength = "50" value = "$af">
   </td></tr>
 <tr><td>
   Department
  </td><td>
   <input type = "text" name = "department" size = "30" maxlength = "50" value = "$d">
   </td></tr>
 <tr><td>
   Address line 1
  </td><td>
    <input type = "text" name = "address" size = "50" maxlength = "100" value = "$a">
   </td></tr>
 <tr><td>
 Address line 2 (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "address2" size = "50" maxlength = "100" value = "$a2">
   </td></tr>
 <tr><td>
   City 
  </td><td>
    <input type = "text" name = "city" size = "50" maxlength = "100" value = "$c">
   </td></tr>
<tr><td>
   State/Province 
  </td><td>
    <input type = "text" name = "state" size = "50" maxlength = "100" value = "$state">
   </td></tr>
 <tr><td>
  Postal Code 
  </td><td>
    <input type = "text" name = "postal_code" size = "30" maxlength = "30" value = "$p">
 <tr><td>
 Country of Residence 
  </td><td>
    <select name="country" size = "1">
    <option VALUE="$cr">$cr
    <option value="none">Please Choose a Country</option>

';
    #prints the countries of the world for the selectbox
    printworld();

print qq'                                                   

    </select>
   </td></tr>
 <tr><td>
 Personal Homepage (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "homepage" size = "50" maxlength = "50" value = "$h">
   </td></tr>
 <tr><td>
    Departmental/Group Homepage (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "homepage2" size = "50" maxlength = "50" value = "$h2">
   </td></tr>
 <tr><td>
  Primary Email Address 
  </td><td>
    <input type = "text" name = "email" size = "50" maxlength = "50" value = "$e">
   </td></tr>
 <tr><td>
    Alternate email Address (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "email2" size = "50" maxlength = "50" value = "$e2">
   </td></tr>
 <tr><td>
  Research Interests
  </td><td>
    <textarea rows=3 cols=50 name="research" wrap="physical">$r</textarea>
   </td></tr>
 <tr><td>
   Country of Origin 
  </td><td>
   <select name="origin_country" size = "1">
    <option VALUE="$co">$co
    <option value="none">Please Choose a Country</option>

';
    #prints the countries of the world for the selectbox
    printworld();

print qq'

    </select>
   </td></tr>
<tr>
  <td colspan=2 align=right>
    <input type="submit" name = "submit_check" value="Submit Form">
    <input type="reset" value="Undo Corrections">
    <input type="submit" name = "submit_entry" value="Start Over">
<br><br>
    <a href= "registry.cgi">Back Home</a><i> (Data will not be saved)</i>
  </td></tr>
 </table>
</form>
</body>
</html>
';
}



#This function will print out its own html page.  It will check the data that 
#was submitted and prompt for re-entry if errors are found.
sub checkentry{
    #get the cgi that was passed in
    my $cgi = shift;

    #clear out the arrays that holds the empty fields
    my @emptyfields = ();
    my @emptyselects = ();

    #clear out old errors arrays
    my @errors = ();
    
    #flags for errors in email and homepage
    $ef = $e2f = $hf = $h2f = $af = 0;

    #print a header
    print $cgi->header();
    
    #finds the empty field names
    foreach(@FIELD_NAMES){
	#if the parameters are empty, save in emptyfields array
	if($cgi->param($_) eq ""){
	    push @emptyfields, $_;
	}
    }

    #finds the empty select lists
    foreach(@SELECT_NAMES){
	#if select fields are empty, save in emptyselects array
	if($cgi->param($_) eq "none"){
	    push @emptyselects, $_;
	}
    }

    #if there are any empty fields, then print another field for the user to enter their information
    if(@emptyfields || @emptyselects){
	
	#this print statement prints out the start of the empty fields webpage
	print qq'
	<html><head><title>Empty Fields</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Empty Fields</h2>
	    <hr noshade>
 <p>The following <font color = ff0000 >required</font> fields have been left empty.  Please re-enter your responses.  Thank You.</p>
 <form method = post>

'; 

	#makes a field for each of the empty fields found
	if(@emptyfields){
	    foreach(@emptyfields){
		#remove underscores
	        if($_ =~ /(.*)_(.*)/g){
		    my $temp = $1." ".$2;
		    print"$temp ";
		}
		else{
		    print "$_ ";
		}
		
		#makes a textarea if the research was left empty
		if($_ =~ /research/){
		    print " interests <br> <textarea rows=3 cols=50 name=\"research\" wrap=\"physical\"></textarea><br><br>";
		}
		elsif($_ =~ /state/){
		    print "/province  <input type = \"text\" name = \"$_\" size = \"50\" maxlength = \"50\"><br><br>";
		}
		#if not research or state, just makes a text field
		else{
		    print "<input type = \"text\" name = \"$_\" size = \"50\" maxlength = \"50\"><br><br>";
		}
	    }
	}
	
	#makes a select field for each empty field found
	if(@emptyselects){
	    foreach(@emptyselects){

		#prints the needed prompt
		if($_ =~ /origin/){
		    print "Country of Origin ";
		    #makes the select field
		    print qq'
                    <select name=$_ size = "1">
                    <option value="none">Please Choose a Country</option>
';
		    #this will print the countries of the world for the selectbox
		    printworld();
		    print qq'
                    </select><br><br>
';
		}
		#prints prompt for country of residence because the field 
		#name is not proper to print out
		elsif($_ =~ /^country/){
		    print "Country of Residence ";
		    #makes the select field
		    print qq'
                    <select name=$_ size = "1">
                     <option value="none">Please Choose a Country</option>
';
		    #this will print the countries of the world for the selectbox
		    printworld();
		    print qq'
                    </select><br><br>
';
		}
		#prints the prompt for status because the field name
		#is not proper to print out
		elsif($_ =~ /status/){
		    print "Job title/position ";
		    #makes the select field
		    print qq'
		    <select name="status" size = "1">
			<option value="none">Choose One</option>
			<option VALUE="Student">Student
			<option VALUE="Professor">Professor
			<option VALUE="Researcher">Researcher
			<option VALUE="Other">Other
			</select><br><br>
';	
		}
	    }
	}
		  
		  

	#makes hidden fields for the input fields that were not empty, to pass the 
	#data back to this function for testing/saving
	foreach $i (@FIELD_NAMES,@SELECT_NAMES){
	    #reset counter
	    $foundflag = 0;
	    #check each empty field for a match with $i
	    foreach $j (@emptyfields){
		if($i eq $j){
		    $foundflag++;
		}
	    }
	    #check each empty select field for a match with $i
	    foreach $k (@emptyselects){
		if ($i eq $k){
		    $foundflag++;
		}
	    }
	    #if the field was not found to be empty, pass its value as a hidden field
	    if($foundflag == 0){
		print $cgi->hidden(-name=> $i, -value=> $cgi->param('$i')=> -override=> 1);
	    }
	}
	#pass the non-required email,homepage & address to the next cgi
	print $cgi->hidden(-name=> "email2", -value=> $cgi->param('email2')=> -override=> 1);
	print $cgi->hidden(-name=> "homepage", -value=> $cgi->param('homepage')=> -override=> 1);
	print $cgi->hidden(-name=> "homepage2", -value=> $cgi->param('homepage2')=> -override=> 1);
	print $cgi->hidden(-name=> "address2", -value=> $cgi->param('address2')=> -override=> 1);

	#print end of empty field webpage, loop back to checkentry with submit button
	print <<EndHTML;
	<br><br>
	    <input type = "submit" name = "submit_check" value = "submit data">
	    </form>
	    <a href = "registry.cgi">Home</a><i> (Data will not be saved)</a>		    
	    </body><br>
	    </html>
EndHTML
	    
}
    #else, there were no empty fields, so check for student/other status, and the homepage and email syntax, and move on
    else{
	
	#process further if the status is other
	if($cgi->param('status') =~ /^other/gi && $cgi->param('other') eq ""){
	    
	    #this print statement prints out the start of the additional information webpage
	    print qq'
	<html><head><title>Additional Information</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Additional Information</h2>
	    <hr noshade>
 <p align = center >What is your job title or positiion? Briefly describe what you do:
</p>
 <form method = post>

'; 
	    #print a field for the additional info needed for "other" status
	    print "Job title/position <input type = \"text\" name = \"other\" size = \"50\" maxlength = \"100\"><br><br>";

	    #prints the end of the webpage
	    print "<br>";
	    
	    #pass hidden fields back to the next cgi for all variables
	    foreach (@FIELD_NAMES,@SELECT_NAMES){
		print $cgi->hidden(-name=> $_, -value=> $cgi->param('$_')=> -override=> 1);
	    }
	    print $cgi->hidden(-name=> "email2", -value=> $cgi->param('email2')=> -override=> 1);
	    print $cgi->hidden(-name=> "homepage", -value=> $cgi->param('homepage')=> -override=> 1);
	    print $cgi->hidden(-name=> "homepage2", -value=> $cgi->param('homepage2')=> -override=> 1);
	    print $cgi->hidden(-name=> "address2", -value=> $cgi->param('address2')=> -override=> 1);

	    #print submit buttons
	    print "<input type = \"submit\" name = \"submit_check\" value = \"submit data\"><br><br>";
	    print "</form><a href = \"registry.cgi\">Home</a> <i> (Data will not be saved)</i></html>";

	}
	
	#process further if the status is student
	elsif($cgi->param('status') =~ /^student/gi && ($cgi->param('advisor') eq "" || $cgi->param('a_email') eq "")){
	    
	    #this print statement prints out the start of the empty fields webpage
	    print qq'
	<html><head><title>Additional Information</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Additional Information</h2>
	    <hr noshade>
 <p align = center >Additional information is required because of your "student" title.</p>
 <form method = post>

'; 
	    #prints out the input variables, only for the needed inputs. 
	    print "<table><tr><td>";
	    if($cgi->param('advisor') eq ""){
		print "Name of Thesis Advisor/Research Supervisor </td><td><input type = \"text\" name = \"advisor\" size = \"50\" maxlength = \"50\"></td></tr>";
	    }
	    else{
		print $cgi->hidden(-name=> "advisor", -value=> $cgi->param('advisor'), -override=> 1);
	    }
	    if($cgi->param('a_email') eq ""){
		print "<tr><td>Email of Thesis Advisor/Research Supervisorisor </td><td><input type = \"a_email\" name = \"a_email\" size = \"50\" maxlength = \"50\"></td></tr><br>";
	    }
	    else{
		print $cgi->hidden(-name=> "a_email", -value=> $cgi->param('a_email'), -override=> 1);
	    }



	    #prints the end of the webpage
	    print "<br></table>";
	    
	    #pass the hidden fields for the next cgi for all variables
	    foreach (@FIELD_NAMES,@SELECT_NAMES){
		print $cgi->hidden(-name=> $_, -value=> $cgi->param('$_')=> -override=> 1);
	    }    
	    print $cgi->hidden(-name=> "email2", -value=> $cgi->param('email2')=> -override=> 1);
	    print $cgi->hidden(-name=> "homepage", -value=> $cgi->param('homepage')=> -override=> 1);
	    print $cgi->hidden(-name=> "homepage2", -value=> $cgi->param('homepage2')=> -override=> 1);
	    print $cgi->hidden(-name=> "address2", -value=> $cgi->param('address2')=> -override=> 1);

	    #print submit buttons
	    print "<input type = \"submit\" name = \"submit_check\" value = \"submit data\"><br><br>";
	    print "</form><a href = \"registry.cgi\">Home</a><i> (Data will not be saved)</i></body><br></html>";

	}

	#else the status is not other or student, so move on to check syntax
	else{

	#add 'http' to the homepage unless it already has two //'s in it
	if($cgi->param('homepage') ne ""){
	    $link = $cgi->param('homepage');
	    $link="http://".$link  unless $link =~ /\/\//;
	}
	if($cgi->param('homepage2') ne ""){
	    $link2 = $cgi->param('homepage2');
	    $link2="http://".$link2  unless $link2 =~ /\/\//;
	}

	#checks the syntax of the homepage given
	if($cgi->param('homepage') ne ""){
	    if($cgi->param('homepage') !~ /^[\S]+\.[\w]{2,4}(\/.*)?$/){
		
		#push homepage on @errors if it doesn't match the syntax, and set hompeage flag $hf
		push @errors, "homepage";
		$hf = 1;
	    }
	}

	#check the syntax of the research/departmental url, if one is given
	if($cgi->param('homepage2') ne ""){
	    if($cgi->param('homepage2') !~ /^[\S]+\.[\w]{2,4}(\/.*)?$/){

		#push homepage2 on @errors if it doesn't match the syntax, and set hompeage2 flag $h2f
		push @errors, "homepage2";
		$h2f = 1;
	    }
	}

	#checks the syntax of the email account given
	if($cgi->param('email')!~ /[\w\-]+\@[\w\-\.]+\.[\w\-]{2,4}$/){

	    #push email on @errors if it doesn't match the syntax, and set email flag $ef
	    push @errors, "email";
	    $ef = 1;
	}
	
	#check the syntax of the alternate email, if one is given
	if($cgi->param('email2') ne ""){
	    if($cgi->param('email2') !~ /[\w\-]+\@[\w\-\.]+\.[\w\-]{2,4}$/){

		#push email2 on @errors if it doesn't match the syntax, and set email2 flag $e2f
		push @errors, "email2";
		$e2f = 1;
	    }
	}
	#check the syntax of the advisor email, if one is given
	if($cgi->param('a_email') ne ""){
	    if($cgi->param('a_email') !~ /[\w\-]+\@[\w\-\.]+\.[\w\-]{2,4}$/){

		#push advisor email on @errors if it doesn't match the syntax, and set advisor email flag $af
		push @errors, "a_email";
		$af = 1;
	    }
	}
	
	#if errors are found with the email/homepage syntax, this code is ran
	if(@errors){
	    
	    #this print statement prints out the start of the errors webpage
	    print qq'
	<html><head><title>Errors</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Errors</h2>
	    <hr noshade>
 <p>The following errors have been found.  Please re-enter your responses.  Thank You.</p>
 <form method = post>

'; 
	    #prints out a field for each of the errors found
	    foreach(@errors){
		my $temp = $cgi->param($_); #make a copy of the parameter
		my $temp2 = $cgi->param($_); #make a copy of the parameter
		print "\'",$cgi->param($_),"\' was found to be invalid.<br>";

		#checks for advisor email problems
		if($_ eq "a_email"){
		    #Check for common email errors, print messages
		    if($temp2 !~ /.*@.*/){
			print "No '\@' symbol was found.  Please enter a valid email address. If you are concerned about spam, insert xxxx into your address. <br>";
		    }
		    elsif($temp2 !~ /.+\@.+\.[\w\-]{2,4}$/){
			print "Domain is not 2-4 letters.  Please enter a legal domain for the email address.<br>";
		    }
		    print "Email of Thesis Advisor/Research Supervisor <br>";
		}

		#checks for secondary email problems
		elsif($_ eq "email2"){
		    #Check for common email errors, print messages
		    if($temp2 !~ /.*@.*/){
			print "No '\@' symbol was found.  Please enter a valid email address. If you are concerned about spam, insert xxxx into your address. <br>";
		    }
		    elsif($temp2 !~ /.+\@.+\.[\w\-]{2,4}$/){
			print "Domain is not 2-4 letters.  Please enter a legal domain for the email address.<br>";
		    }
		    print "Alternate email (<font color = 0000ff>*</font>)<br>";
		}

		#checks for departmental/group homepage problems
		elsif($_ eq "homepage2"){
		    print "We detected errors with the address format.  Please check the syntax.<br>";
		    print "Departmental/Group Homepage (<font color = 0000ff>*</font>)<br>";
		}

		#checks for homepage problems
		elsif($_ eq "homepage"){
		    print "We detected errors with the address format.  Please check the syntax.<br>";		    
		    print "Personal Homepage (<font color = 0000ff>*</font>)<br>";
		}

		#checks for email problems
		elsif($_ eq "email"){
		    #Check for common email errors, print messages
		    if($temp2 !~ /.*@.*/){
			print "No '\@' symbol was found.  Please enter a valid email address. If you are concerned about spam, insert xxxx into your address. <br>";
		    }
		    elsif($temp2 !~ /.+\@.+\.[\w\-]{2,4}$/){
			print "Domain is not 2-4 letters.  Please enter a legal domain for the email address.<br>";
		    }
		    print "primary email <br>";
		}

		#print the field for the error
		print "<input type = \"text\" name = \"$_\" size = \"50\" maxlength = \"50\" value = \"$temp\"><br><br>";
	    }
	    
	    #save the elements for next cgi to use them unless their syntax error flags are set
	    print $cgi->hidden(-name=> "status", -value=> $cgi->param('status')=> -override, 1);
	    print $cgi->hidden(-name=> "last_name", -value=> $cgi->param('last_name')=> -override, 1);
	    print $cgi->hidden(-name=> "first_name", -value=> $cgi->param('first_name')=> -override, 1);
	    print $cgi->hidden(-name=> "affiliation", -value=> $cgi->param('affiliation')=> -override, 1);
	    print $cgi->hidden(-name=> "department", -value=> $cgi->param('department')=> -override, 1);
	    print $cgi->hidden(-name=> "address", -value=> $cgi->param('address')=> -override, 1);
	    print $cgi->hidden(-name=> "city", -value=> $cgi->param('city')=> -override, 1);
	    print $cgi->hidden(-name=> "state", -value=> $cgi->param('state')=> -override, 1);
	    print $cgi->hidden(-name=> "postal_code", -value=> $cgi->param('postal_code')=> -override, 1);
	    print $cgi->hidden(-name=> "country", -value=> $cgi->param('country')=> -override, 1);
	    print $cgi->hidden(-name=> "homepage", -value=> $cgi->param('homepage')=> -override, 1)unless($hf);
	    print $cgi->hidden(-name=> "homepage2", -value=> $cgi->param('homepage2')=> -override, 1)unless($h2f);
	    print $cgi->hidden(-name=> "email", -value=> $cgi->param('email')=> -override, 1)unless($ef);
	    print $cgi->hidden(-name=> "email2", -value=> $cgi->param('email2')=> -override, 1)unless($e2f);
	    print $cgi->hidden(-name=> "research", -value=> $cgi->param('research')=> -override, 1);
	    print $cgi->hidden(-name=> "origin_country", -value=> $cgi->param('origin_country')=> -override, 1);
	    print $cgi->hidden(-name=> "other", -value=> $cgi->param('other')=> -override, 1)unless($cgi->param('other')eq "");
	    print $cgi->hidden(-name=> "advisor", -value=> $cgi->param('advisor')=> -override, 1)unless($cgi->param('advisor') eq "");
	    print $cgi->hidden(-name=> "a_email", -value=> $cgi->param('a_email')=> -override, 1)unless($af || $cgi->param('a_email') eq "");
	    print $cgi->hidden(-name=> "address2", -value=> $cgi->param('address2')=> -override=> 1);


	    #prints the end of the webpage
	    print <<EndHTML
		<br><br>
		<input type = "submit" name = "submit_check" value = "submit data"><br><br>
		</form>
		<a href = "registry.cgi">Home</a><i> (Data will not be saved)</i>
		</body><br>
		</html>
EndHTML

}
	#if no errors are found, then we print out a data confirmation page
	else{
	    
	    #remove underscores from the values
	    $country = $cgi->param('country');
	    $origin_country = $cgi->param('origin_country');
	    $country =~ s/_/ /g;
	    $origin_country =~ s/_/ /g;
	    
	    #saves the non-underscore paramaters back into the cgi values
	    $cgi->param(country=>"$country");
	    $cgi->param(origin_country=>"$origin_country");
	    
	    #The following string of print statements will print out a confirmation
	    #webpage which will print out the users' data on it.
	    print $cgi->start_html(-title=>"Confirm Data");
	    print $cgi->h2("Confirm Data");
	    print "Here's what you entered:<p>\n";
	    print "<b>Job title/position: </b>",$cgi->param('status');
	    if($cgi->param('status') =~ /^other/gi){
		print "-",$cgi->param('other'),$cgi->br;
	    }
	    else{
		print $cgi->br;
	    }
	    if($cgi->param('status') =~ /^student/gi){
		print "<b>Name of Thesis Advisor/Research Supervisor: </b>",$cgi->param('advisor'),$cgi->br;
		print "<b>Email of Thesis Advisor/Research Supervisor: </b>",$cgi->param('a_email'),$cgi->br;
	    }
	    print "<b>Last Name(s): </b>",$cgi->param('last_name'),$cgi->br;
	    print "<b>First Name: </b>",$cgi->param('first_name'),$cgi->br;
	    print "<b>Organization: </b>",$cgi->param('affiliation'),$cgi->br;
	    print "<b>Department: </b>",$cgi->param('department'),$cgi->br;
	    print "<b>Address line 1: </b>",$cgi->param('address'),$cgi->br;
	    print "<b>Address line 2: </b>",$cgi->param('address2'),$cgi->br;
	    print "<b>City: </b>",$cgi->param('city'),$cgi->br;
	    print "<b>State/Province: </b>",$cgi->param('state'),$cgi->br;
	    print "<b>Postal Code: </b>",$cgi->param('postal_code'),$cgi->br;
	    print "<b>Country of Residence: </b>",$cgi->param('country'),$cgi->br;
	    if( $cgi->param('homepage')){
		print "<b>Personal Homepage: </b>",$cgi->a({-href=>$link},$cgi->param('homepage')),$cgi->br;
	    }
	    else{
		print "<b>Personal Homepage: </b>",$cgi->br;
	    }
	    if($cgi->param('homepage2')){
		print "<b>Departmental/Group Homepage: </b>",$cgi->a({-href=>$link2},$cgi->param('homepage2')),$cgi->br;
	    }
	    else{
		print "<b>Departmental/Group Homepage: </b><br>";
	    }
	    print "<b>Primary Email: </b>",$cgi->param('email'),$cgi->br;
	    print "<b>Alternate Email: </b>",$cgi->param('email2'),$cgi->br;
	    print "<b>Research Interests: </b>",$cgi->param('research'),$cgi->br;
	    print "<b>Origin Country: </b>",$cgi->param('origin_country'),$cgi->br;
	    print $cgi->br,$cgi->br;
	    
	    print "<form method = post>";
	    
	    #save all of the fields for next cgi to use them	    
	    print $cgi->hidden(-name=> "status", -value=> $cgi->param('status')=> -override, 1);
	    print $cgi->hidden(-name=> "last_name", -value=> $cgi->param('last_name')=> -override, 1);
	    print $cgi->hidden(-name=> "first_name", -value=> $cgi->param('first_name')=> -override, 1);
	    print $cgi->hidden(-name=> "affiliation", -value=> $cgi->param('affiliation')=> -override, 1);
	    print $cgi->hidden(-name=> "department", -value=> $cgi->param('department')=> -override, 1);
	    print $cgi->hidden(-name=> "address", -value=> $cgi->param('address')=> -override, 1);
	    print $cgi->hidden(-name=> "city", -value=> $cgi->param('city')=> -override, 1);
	    print $cgi->hidden(-name=> "state", -value=> $cgi->param('state')=> -override, 1);
	    print $cgi->hidden(-name=> "postal_code", -value=> $cgi->param('postal_code')=> -override, 1);
	    print $cgi->hidden(-name=> "country", -value=> $cgi->param('country')=> -override, 1);
	    print $cgi->hidden(-name=> "homepage", -value=> $cgi->param('homepage')=> -override, 1);
	    print $cgi->hidden(-name=> "homepage2", -value=> $cgi->param('homepage2')=> -override, 1);
	    print $cgi->hidden(-name=> "email", -value=> $cgi->param('email')=> -override, 1);
	    print $cgi->hidden(-name=> "email2", -value=> $cgi->param('email2')=> -override, 1);
	    print $cgi->hidden(-name=> "research", -value=> $cgi->param('research')=> -override, 1);
	    print $cgi->hidden(-name=> "origin_country", -value=> $cgi->param('origin_country')=> -override, 1);
	    print $cgi->hidden(-name=> "other", -value=> $cgi->param('other')=> -override, 1);
	    print $cgi->hidden(-name=> "advisor", -value=> $cgi->param('advisor')=> -override, 1);
	    print $cgi->hidden(-name=> "a_email", -value=> $cgi->param('a_email')=> -override, 1);
	    print $cgi->hidden(-name=> "address2", -value=> $cgi->param('address2')=> -override=> 1);


	    #prints the end of the webpage
	    print <<EndHTML;
	    <input type = "submit" name = "submit_good" value = "Submit Entry"><i> (Entry will be posted upon approval)</i><br><br>
		<input type = "submit" name = "submit_bad" value = "Make Corrections"><br><br>
		<input type = "submit" name = "submit_entry" value = "Start Over"><br><br>
		</form>
		    <a href = "registry.cgi">Home</a><i> (Data will not be saved)</i>
EndHTML
    
print $cgi->end_html;
	}
    }
    }
}


#This function will print out its own html page.  It will make the 
#data form for our comments page.
sub commentsform{
    #get the cgi that was passed in
    my $cgi = shift;

    print $cgi->header();
    
    #this print statement will print out the whole html page for the feedback form.
    print qq'
<html>
  <head>
    <title>Comments Form</title>
   
  </head>

<body bgcolor="#ffffff">

  <h2 align = center>Comments Form</h2>

<p align = center><font color = 0000ff>Blue asterisks mark OPTIONAL fields.</font><br>Thank you for your time.</p>

<hr noshade>

<form method = "POST">

<table border = 0>
 <tr><td>
    Your Name (<font color = 0000ff>*</font>)
   </td><td>
 <input type = "text" name = "c_name" size = "30" maxlength = "50">
   </td></tr>
 <tr><td>
    Email Address (<font color = 0000ff>*</font>)
  </td><td>
    <input type = "text" name = "c_email" size = "50" maxlength = "50">
   </td></tr>
 <tr><td>
    Comments/feedback 
  </td><td>
    <textarea rows=10 cols=40 name="comments" wrap="physical"></textarea>
   </td></tr>

<tr>
 <td colspan=2 align=right>
    <input type="submit" name = "submit_check_comments" value="Submit Form">
    <input type="reset" value="Clear Form"><br>
    <a href= "registry.cgi">Back Home</a><i> (Comments will not be sent)</i>
  </td></tr>
 </table></font>
</form>
</body>
</html>
';
}



#This function will print out its own webpage.  It will check the comments
#and send them to $MAIL if they are OK.
sub checkcomments{
    #get the cgi that was passed in
    my $cgi = shift;
    
    #array that holds the empty fields
    my @emptyfields = ();
    
    #clear out old errors arrays
    my @errors = ();
    
    print $cgi->header();
    
    #finds the empty field names for the required fields.
    #The only required field is comments.  Name and email are 
    #not required for this section.
    foreach("comments"){
	if($cgi->param($_) eq ""){
	    push @emptyfields, $_;
	}
    }

    #if there are any empty fields, then print another field for the user to enter their information
    if(@emptyfields){
	
	#this print statement prints out the start of the empty fields webpage
	print qq'
	<html><head><title>Empty Fields</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Empty Fields</h2>
	    <hr noshade>
 <p>Please enter the comments you wish to send, or click the "Back Home" link at the bottom to go back to the main page.  Thank You.</p>
 <form method = post>
';

	#for each of the empty fields
	foreach(@emptyfields){
	    #makes a textarea if the comments were left empty
	    if($_ =~ /comments/){
		print "Comments:<br> <textarea rows=10 cols=40 name=\"comments\" wrap=\"physical\"></textarea><br><br>";
	    }

	    #make a text field for the others if they were left empty
	    elsif($_ =~ /name/){
		print "Your Name:<br><input type = \"text\" name = \"c_name\" size = \"50\" maxlength = \"50\"><br><br>";
	    }
	    elsif($_ =~ /email/){
		print "Email Address:<br><input type = \"text\" name = \"c_email\" size = \"50\" maxlength = \"50\"><br><br>";
	    }
	}	
    
	
	#makes hidden fields for the input fields that were not empty, to pass the 
	#data back to this function for testing/saving
	foreach $i ("c_name","c_email","comments"){

	    #reset counter
	    $foundflag = 0;

	    #check each empty field for a match
	    foreach $j (@emptyfields){
		if($i eq $j){
		    $foundflag++;
		}
	    }
	    #if the field was not found to be empty, pass its value as a hidden field
	    if($foundflag == 0){
		print $cgi->hidden(-name=> $i, -value=> $cgi->param('$i')=> -override=> 1);
	    }
	}
	
	#prints the end of the webpage
	print <<EndHTML;
	    <br><br>
	    <input type = "submit" name = "submit_check_comments" value = "submit data"><br><br>
	    </form>
	    <a href = "registry.cgi">Home</a><i> (Comments will not be sent)</i>
	    </body><br>
	    </html>
EndHTML

}
    #if no empty fields, then check the information and move on
    else{	
	#checks the syntax of the email account given
	if($cgi->param('c_email')!~ /[\w\-]+\@[\w\-\.]+\.[\w\-]{2,4}$|^$/){
	    push @errors, "c_email";
	}
	
	if(@errors){
	    
	    #save the email parameters in $temp and $temp2 for processing
	    #syntax checks.
	    my $temp = $cgi->param('c_email');
	    my $temp2 = $cgi->param('c_email');
	    #this print statement prints out the start of the errors webpage
	    print qq'
	<html><head><title>Errors</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Errors</h2>
	    <hr noshade>
 <p>The following errors have been found.  Please re-enter your responses.  Thank You.</p>
 <form method = post>

'; 
	    #Check for common email errors, print messages
	    if($temp2 !~ /.*@.*/){
			print "No '\@' symbol was found.  Please enter a valid email address. If you are concerned about spam, insert xxxx into your address. <br>";
	    }
	    elsif($temp2 !~ /.+\@.+\.[\w\-]{2,4}$/){
		print "Domain is not 2-4 letters.  Please enter a legal domain for the email address.<br>";
	    }

	    #prints out a field if the email address was invalid
	    print "Email Address:<br>";
	    print "<input type = \"text\" name = \"c_email\" size = \"50\" maxlength = \"50\" value = $temp><br><br>";
	    
	    
	    #save the elements for next cgi to use them
	    print $cgi->hidden(-name=> "c_name", -value=> $cgi->param('c_name')=> -override, 1);
	    print $cgi->hidden(-name=> "comments", -value=> $cgi->param('comments')=> -override, 1);
	    
	    #prints the end of the webpage
	    print <<EndHTML;
	    <br>
		<input type = "submit" name = "submit_check_comments" value = "submit data"><br><br>
		</form>
		<a href = "registry.cgi">Home</a><i> (Comments will not be sent)</i>
		</body><br>
		</html>
EndHTML

}
    #if no errors found, then send the comments, and print a thank you page
    else{

	$ENV{PATH} = "/bin:/usr/bin";
	delete @ENV{ qw( IFS CDPATH ENV BASH_ENV ) };
	

	#prepare the variables for sending, in case they are empty
	if($cgi->param('c_name') eq ""){
	    $cgi->param(c_name=>"No Name Given");
	}

	#call the function that sends the comments to the administrator
	send_feedback($cgi->param('c_name'),$cgi->param('c_email'),$cgi->param('comments'));

	#The following string of print statements will print out a thank you
	#webpage telling the user that the comments were sent
	print qq'
	<html><head><title>Thank You</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr size=5 noshade>
	    <h2 align ="CENTER">Thank You</h2>
	    <hr size = 5 noshade>
         <br>
         <h3 align = "center">Your comments have been sent.Thank you for your feedback.</h3><br><br>
         <a href="registry.cgi">Back Home</a>
        </html>
';
    }
    }

}



#This function will send the comments that a user entered.  It will
#use sendmail from the /usr/lib/ directory, and send to the address 
#in the global variable $MAIL
sub send_feedback{
    #get name if given
    my $username = shift;
    #get reply-to address if given
    my $from_email = shift;
    #get comments
    my $message = shift;
    
    #change @ to \@ in email
    $from_email =~ s/@/\@/g;

    #open the sendmail program
    open MAIL, "| /usr/lib/sendmail -t -i" or dienice("Couldn't open sendmail: $! \n");
    
    #send message
    print MAIL <<END_OF_MESSAGE;
To: $MAIL
From: $from_email
Reply-To: $from_email
Subject: Latin CGI Feedback
Feedback from $username:


$message
END_OF_MESSAGE

#close sendmail
close MAIL or dienice("Couldn't close sendmail: $! \n");

}


#This function saves the information into the data file if the user chooses so,
#and reverts to the rootpage.
sub saveinfo{
    #get the cgi, so the data can be saved
    my $q = shift;

    print $q->header();
    
    #append the extra information to the status if the status is "other" or "student"
    #this way each entry still has the same amount of fields in it.
    if($q->param('status') =~ /^other/gi){
	my $tmp2 = $q->param('other');
	my $tmp = "Other%%%" . $tmp2;	
	$q->param(status=>"$tmp");
    }
    if($q->param('status') =~ /^student/gi){
	my $ad = $q->param('advisor');
	my $aem = $q->param('a_email');
	my $tmp = "Student%%%" . $ad . "%%%" . $aem;
	$q->param(status=>"$tmp");
    }

    #This goes through the data and checks for newlines and pipes before saving it. 
    #If these characters were allowed into the data file, it would be corrupted.
    foreach(@FIELD_NAMES, "address2"){
	my $temp = $q->param($_);

	#replace newlines and hard returns in the data with spaces
	$temp =~ s/\n|\r/  /g;
	
	#replace |'s in the data with a : 
	$temp =~ s/\|/:/g;

	#save the new value back into the cgi parameter
	$q->param($_=>"$temp");
    }

    #Get time and date
    ($sec,$min,$hr,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    $mon++;
    $year += 1900;

    #get the number of entries in the registry
    #for individual number
    open(FP2,"pendingadd/pendingadd.txt") or dienice("Couldn't open111 pendingadd.txt: $! \n");
    #lock the file in case of multiple users
    flock(FP2,2);
    #move to the beginning of the file
    seek(FP2,0,0);

    #get the number of members.  Used for assigning a member number to the
    #next member.  Saved in entrycount.
    @lines = <FP2>;
    $entrycount = @lines;
    $entrycount++;
	
    close(FP2);

    #open pendingadd.txt to add the new addition
    open(FP2,"pendingadd/pendingadd.txt") or dienice("Couldn't open pendingadd.txt: $! \n");
    
    #lock the file in case of multiple users
    flock(FP2,2);

    #move to the beginning of the file
    seek(FP2,0,0);

    #find the next spot to save an entry in pendingadd file
    $tmp = <FP2>;

    #while tmp does not match approved or rejected symbols (A: or R:)
    #save in @beginning
    while($tmp !~ /^(A:)|(R:).+|^$/){
	push @beginning,$tmp;
	$tmp = <FP2>;
    }

    #save the rest of the file in @end
    @end = <FP2>;

    #close file
    close(FP2);

    #open pendingadd.txt and re-write the info with the new entry in it
    open(FP3,">pendingadd/pendingadd.txt") or dienice("Couldn't open pendingadd.txt: $! \n");

    #Lock the file, and seek to the beginning
    flock(FP3,2);
    seek(FP3,0,0);

    #print the beginning of the pendingadd file before the addition
    #to pendingadd
    print FP3 @beginning;


    
    #print new information to the output file
    print FP3 "$entrycount|";
    print FP3 $q->param('status'),"|";
    print FP3 $q->param('last_name'),"|",$q->param('first_name'),"|",
    $q->param('affiliation'),"|",$q->param('department'),"|",$q->param('address'),"|",$q->param('address2'),"|",$q->param('city'),"|",$q->param('state'),"|",$q->param('postal_code'),"|",$q->param('country'),"|",$q->param('homepage'),"|",$q->param('homepage2'),"|",$q->param('email'),"|",$q->param('email2'),"|",$q->param('research'),"|",$q->param('origin_country'),"|$hr:$min:$sec,$mon-$mday-$year|",$ENV{'REMOTE_HOST'},"-",$ENV{'REMOTE_ADDR'},"\n";   

    #print the buffer from the while loop ($tmp) and the end of the file
    print FP3 $tmp,@end;

    close(FP3);

    #form the transaction file name based on name, date and time
    my $filename = $entrycount."-". $hr.":".$min.":".$sec.",".$mon."-".$mday."-".$year;
    
    #replace spaces in filename
    $filename =~ s/ /_/g;

    #open the file for the transaction
    open(FP2,">pendingadd/$filename.txt") or dienice("Couldn't open $filename.txt: $! \n");
    
    #lock the file in case of multiple users
    flock(FP2,2);

    #move to the beginning of the file
    seek(FP2,0,0);

    #print information to the output file
    print FP2 "$entrycount|";
    print FP2 $q->param('status'),"|";
    print FP2 $q->param('last_name'),"|",$q->param('first_name'),"|",
    $q->param('affiliation'),"|",$q->param('department'),"|",$q->param('address'),"|",$q->param('address2'),"|",$q->param('city'),"|",$q->param('state'),"|",$q->param('postal_code'),"|",$q->param('country'),"|",$q->param('homepage'),"|",$q->param('homepage2'),"|",$q->param('email'),"|",$q->param('email2'),"|",$q->param('research'),"|",$q->param('origin_country'),"|$hr:$min:$sec,$mon-$mday-$year|",$ENV{'REMOTE_HOST'},"-",$ENV{'REMOTE_ADDR'},"\n";  

    close(FP2);

    #this print statement prints out a thank you page
    print qq'
	<html><head><title>Entry Submitted</title></head>
	    <body BGCOLOR = "ffffff">
	    <hr noshade>
	    <h2 align ="CENTER">Entry Submitted</h2>
	    <hr noshade>
 <p align = center >Thank You.  Your entry has been submitted to the Registry administrator. Once approved you will be added to the Registry.</p> <br><br><a href = registry.cgi>Main Page</a> </body></html>
';
}


#this function will print the countries of latin america, if needed
sub printlatin{
print qq'
                           <option VALUE="Antigua">Antigua
	                   <option VALUE="Argentina">Argentina
		           <option VALUE="Bahamas">Bahamas
         		   <option VALUE="Barbados">Barbados
       			   <option VALUE="Belize">Belize
			   <option VALUE="Bolivia">Bolivia
			   <option VALUE="Brazil">Brazil
			   <option VALUE="Chile">Chile
			   <option VALUE="Colombia">Colombia
			   <option VALUE="Costa_Rica">Costa Rica
			   <option VALUE="Cuba">Cuba
			   <option VALUE="Dominica">Dominica
			   <option VALUE="Dominican_Republic">Dominican Republic
			   <option VALUE="Ecuador">Ecuador
			   <option VALUE="El_Salvador">El Salvador
			   <option VALUE="Grenada">Grenada
			   <option VALUE="Guatemala">Guatemala
			   <option VALUE="Guyana">Guyana
			   <option VALUE="Haiti">Haiti
			   <option VALUE="Honduras">Honduras
			   <option VALUE="Jamaica">Jamaica
			   <option VALUE="Mexico">Mexico
			   <option VALUE="Nicaragua">Nicaragua
			   <option VALUE="Panama">Panama
			   <option VALUE="Paraguay">Paraguay
			   <option VALUE="Peru">Peru
                           <option VALUE="Saint_Kitts_&_Nevis">Saint Kitts & Nevis
			   <option VALUE="Saint_Lucia">Saint Lucia
			   <option VALUE="Saint_Vincent_&_Grenadines">Saint Vincent & Grenadines
			   <option VALUE="Suriname">Suriname
			   <option VALUE="Trinidad_&_Tobago">Trinidad & Tobago
			   <option VALUE="Uruguay">Uruguay
			   <option VALUE="Venezuela">Venezuela
';

}




#this function will print the countries of the world for the select boxes.  It uses 
#the optgroup label for seperating the country types.
sub printworld{
print qq'
                                           
 <optgroup label="----Latin America----">
       
 <option VALUE="Antigua">Antigua
 <option VALUE="Argentina">Argentina
 <option VALUE="Bahamas">Bahamas
 <option VALUE="Barbados">Barbados
 <option VALUE="Belize">Belize
 <option VALUE="Bolivia">Bolivia
 <option VALUE="Brazil">Brazil
 <option VALUE="Chile">Chile
 <option VALUE="Colombia">Colombia
 <option VALUE="Costa_Rica">Costa Rica
 <option VALUE="Cuba">Cuba
 <option VALUE="Dominica">Dominica
 <option VALUE="Dominican_Republic">Dominican Republic
 <option VALUE="Ecuador">Ecuador
 <option VALUE="El_Salvador">El Salvador
 <option VALUE="Grenada">Grenada
 <option VALUE="Guatemala">Guatemala
 <option VALUE="Guyana">Guyana
 <option VALUE="Haiti">Haiti
 <option VALUE="Honduras">Honduras
 <option VALUE="Jamaica">Jamaica
 <option VALUE="Mexico">Mexico
 <option VALUE="Nicaragua">Nicaragua
 <option VALUE="Panama">Panama
 <option VALUE="Paraguay">Paraguay
 <option VALUE="Peru">Peru
 <option VALUE="Saint_Kitts_&_Nevis">Saint Kitts & Nevis
 <option VALUE="Saint_Lucia">Saint Lucia
 <option VALUE="Saint_Vincent_&_Grenadines">Saint Vincent & Grenadines
 <option VALUE="Suriname">Suriname
 <option VALUE="Trinidad_&_Tobago">Trinidad & Tobago
 <option VALUE="Uruguay">Uruguay
 <option VALUE="Venezuela">Venezuela


 <optgroup label="----Rest of World----">

 <option VALUE="Afghanistan">Afghanistan
 <option VALUE="Albania">Albania
 <option VALUE="Algeria">Algeria
 <option VALUE="Andorra">Andorra
 <option VALUE="Angola">Angola
 <option VALUE="Armenia">Armenia
 <option VALUE="Australia">Australia
 <option VALUE="Austria">Austria
 <option VALUE="Azerbaijan">Azerbaijan
 <option VALUE="Bahrain">Bahrain
 <option VALUE="Bangladesh">Bangladesh
 <option VALUE="Belarus">Belarus
 <option VALUE="Belgium">Belgium
 <option VALUE="Benin">Benin
 <option VALUE="Bhutan">Bhutan
 <option VALUE="Bosnia-Herzegovina">Bosnia-Herzegovina
 <option VALUE="Botswana">Botswana
 <option VALUE="Brunei">Brunei
 <option VALUE="Bulgaria">Bulgaria
 <option VALUE="Burkina_Faso">Burkina Faso
 <option VALUE="Burundi">Burundi
 <option VALUE="Cambodia">Cambodia
 <option VALUE="Cameroon">Cameroon
 <option VALUE="Canada">Canada
 <option VALUE="Cape_Verde">Cape Verde
 <option VALUE="Central_African_Republic">Central African Republic
 <option VALUE="Chad">Chad
 <option VALUE="China">China
 <option VALUE="Comoros">Comoros
 <option VALUE="Congo_(DRC)">Congo (DRC)
 <option VALUE="Congo_(RC)">Congo (RC)
 <option VALUE="Cote_d_`Ivoire">Cote d `Ivoire
 <option VALUE="Croatia">Croatia
 <option VALUE="Cyprus">Cyprus
 <option VALUE="Czech_Republic">Czech Republic
 <option VALUE="Denmark">Denmark
 <option VALUE="Djibouti">Djibouti
 <option VALUE="Egypt">Egypt
 <option VALUE="Equatorial_Guinea">Equatorial Guinea
 <option VALUE="Eritrea">Eritrea
 <option VALUE="Estonia">Estonia
 <option VALUE="Ethiopia">Ethiopia
 <option VALUE="Fiji">Fiji
 <option VALUE="Finland">Finland
 <option VALUE="France">France
 <option VALUE="Gabon">Gabon
 <option VALUE="Gambia">Gambia
 <option VALUE="Georgia">Georgia
 <option VALUE="Germany">Germany
 <option VALUE="Ghana">Ghana
 <option VALUE="Greece">Greece
 <option VALUE="Guinea">Guinea
 <option VALUE="Guinea-Bissau">Guinea-Bissau
 <option VALUE="Holy_See">Holy See
 <option VALUE="Hungary">Hungary
 <option VALUE="Iceland">Iceland
 <option VALUE="India">India
 <option VALUE="Indonesia">Indonesia
 <option VALUE="Iran">Iran
 <option VALUE="Iraq">Iraq
 <option VALUE="Ireland">Ireland
 <option VALUE="Israel">Israel
 <option VALUE="Italy">Italy
 <option VALUE="Japan">Japan
 <option VALUE="Jordan">Jordan
 <option VALUE="Kazakhstan">Kazakhstan
 <option VALUE="Kenya">Kenya
 <option VALUE="Kiribati">Kiribati
 <option VALUE="Korea,_North">Korea, North
 <option VALUE="Korea,_South">Korea, South
 <option VALUE="Kuwait">Kuwait
 <option VALUE="Kyrgyzstan">Kyrgyzstan
 <option VALUE="Laos">Laos
 <option VALUE="Latvia">Latvia
 <option VALUE="Lebanon">Lebanon
 <option VALUE="Lesotho">Lesotho
 <option VALUE="Liberia">Liberia
 <option VALUE="Libya">Libya
 <option VALUE="Liechtenstein">Liechtenstein
 <option VALUE="Lithuania">Lithuania
 <option VALUE="Luxembourg">Luxembourg
 <option VALUE="Macedonia">Macedonia
 <option VALUE="Madagascar">Madagascar
 <option VALUE="Malawi">Malawi
 <option VALUE="Malaysia">Malaysia
 <option VALUE="Maldives">Maldives
 <option VALUE="Mali">Mali
 <option VALUE="Malta">Malta
 <option VALUE="Marshall_Islands">Marshall Islands
 <option VALUE="Mauritania">Mauritania
 <option VALUE="Mauritius">Mauritius
 <option VALUE="Micronesia">Micronesia
 <option VALUE="Moldova">Moldova
 <option VALUE="Monaco">Monaco
 <option VALUE="Mongolia">Mongolia
 <option VALUE="Morocco">Morocco
 <option VALUE="Mozambique">Mozambique
 <option VALUE="Myanmar">Myanmar
 <option VALUE="Namibia">Namibia
 <option VALUE="Nauru">Nauru
 <option VALUE="Nepal">Nepal
 <option VALUE="Netherlands">Netherlands
 <option VALUE="New_Zealand">New Zealand
 <option VALUE="Niger">Niger
 <option VALUE="Nigeria">Nigeria
 <option VALUE="Norway">Norway
 <option VALUE="Oman">Oman
 <option VALUE="Pakistan">Pakistan
 <option VALUE="Palau">Palau
 <option VALUE="Papua_New_Guinea">Papua New Guinea
 <option VALUE="Philippines">Philippines
 <option VALUE="Poland">Poland
 <option VALUE="Portugal">Portugal
 <option VALUE="Qatar">Qatar
 <option VALUE="Romania">Romania
 <option VALUE="Russia">Russia
 <option VALUE="Rwanda">Rwanda
 <option VALUE="Samoa">Samoa
 <option VALUE="San_Marino">San Marino
 <option VALUE="Sao_Tome_&_Principe">Sao Tome & Principe
 <option VALUE="Saudi_Arabia">Saudi Arabia
 <option VALUE="Senegal">Senegal
 <option VALUE="Serbia_&_Montenegro">Serbia & Montenegro
 <option VALUE="Seychelles">Seychelles
 <option VALUE="Sierra_Leone">Sierra Leone
 <option VALUE="Singapore">Singapore
 <option VALUE="Slovakia">Slovakia
 <option VALUE="Slovenia">Slovenia
 <option VALUE="Solomon_Islands">Solomon Islands
 <option VALUE="Somalia">Somalia
 <option VALUE="South_Africa">South Africa
 <option VALUE="Spain">Spain
 <option VALUE="Sri_Lanka">Sri Lanka
 <option VALUE="Sudan">Sudan
 <option VALUE="Swaziland">Swaziland
 <option VALUE="Sweden">Sweden
 <option VALUE="Switzerland">Switzerland
 <option VALUE="Syria">Syria
 <option VALUE="Tajikistan">Tajikistan
 <option VALUE="Tanzania">Tanzania
 <option VALUE="Thailand">Thailand
 <option VALUE="Togo">Togo
 <option VALUE="Tonga">Tonga
 <option VALUE="Tunisia">Tunisia
 <option VALUE="Turkey">Turkey
 <option VALUE="Turkmenistan">Turkmenistan
 <option VALUE="Tuvalu">Tuvalu
 <option VALUE="Uganda">Uganda
 <option VALUE="Ukraine">Ukraine
 <option VALUE="United_Arab_Emirates">United Arab Emirates
 <option VALUE="United_States">United States
 <option VALUE="United_Kingdom">United Kingdom
 <option VALUE="Uzbekistan">Uzbekistan
 <option VALUE="Vanuatu">Vanuatu
 <option VALUE="Vietnam">Vietnam
 <option VALUE="Yemen">Yemen
 <option VALUE="Zambia">Zambia
 <option VALUE="Zimbabwe">Zimbabwe

';
}

#function will print an error message
sub dienice{
    my($msg) = @_;
    print "<h2Error</h2>\n";
    print $msg;
    exit;
}
