#!/usr/bin/perl

# delete.cgi
#
# This is a cgi that will allow a administrator to delete
# entries from the registry.
#
# Copyright (C) 2002
# Ted Pedersen, University of Minnesota, Duluth
# tpederse@d.umn.edu
# Brian Rassier, University of Minnesota, Duluth
# rass0028@d.umn.edu
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#-----------------------------------------------------------------------------
#                              Start of program
#-----------------------------------------------------------------------------

use CGI;

#make a new cgi object to use
$cgi = new CGI();

#print the headers
print $cgi->header();

#print the top portion of the root html page
print <<EndHTML;
<html><head><title>Delete a Registry Entry</title></head>
    <body BGCOLOR = "ffffff">
    <h2 align ="CENTER">Delete a Registry Entry</h2>
<hr size=5 noshade><br>
EndHTML

#finds the query string if a user selects a 
#letter link to find names beginning with that letter
if($ENV{'QUERY_STRING'}){
    #split the '&' in the query string
    @values = split(/&/,$ENV{'QUERY_STRING'});
    #split the = to find the letter or other parameters
    foreach $i (@values){
	($varname, $mydata) = split(/=/,$i);
	$in{$varname} = $mydata;
    }
}
#else, there is no querystring so keep processing
else{
    #if no querystring, undefine the querystring hash
    undef(%in);
}

#save the letter/member that was pressed
$member = $in{'member'};

#open registry.txt to read in all the entries to make a list
#of deletable entries
open(INFP,"../approvedadd/registry.txt") or dienice("Couldn't open registry.txt: $! \n");

#lock the file in case of multiple users
flock(INFP,2);

#move to the beginning of the file
seek(INFP,0,0);

#store the data in @data
@data = <INFP>;

#close file
close(INFP);

#if data is found
if(@data){
    #go through each line of data
    foreach $i (@data){
	#remove newline
	chomp($i);

	#split the information
	($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date) = split(/\|/, $i);
	
	#store the file based on last name into the HashOfArrays.
	#HashOfArrays is a hash of the people based on last name.
	#This takes care of the issue of two people having the same last name.
	#if there is a last name already, add to the array of that hash
	if($HashOfArrays{$last_name}){
	    my @temp = @{$HashOfArrays{$last_name}};
	    push @temp,$i;
	    $HashOfArrays{$last_name} = \@temp;
	}
	#if ther is not a last name in the hash, add one
	else{
	    my @temp = ();
	    push @temp, $i;
	    $HashOfArrays{$last_name} = \@temp;
	}
	#make another hash, based on member numbers
	$HashOfNums{$num} = $i;

	#remove underscores from the values
	$country =~ s/_/ /g;
	$origin_country =~ s/_/ /g;
	
    }
}

#if a member is given from the user clicking on one, process it
if($member){
    #if full entry was pressed, find the entry and print it
    if($in{'function'} eq "print"){
	findentry($in{'member'});
    }
    #if delete entry was pressed, call delete_entry with the member number of
    #the entry to be deleted ($in{'member'})
    elsif($in{'function'} eq "delete"){
	delete_entry($in{'member'});
    }
}
#if no input, print all the deletable entries
else{ 
    print "<a href= approve.cgi>Back to Approve</a><br><br>";
    printall();
}

#print the ending html tag
print "</html>";

#this function finds the entry that matches last name, first name, and email, and prints the full entry
sub findentry{
    #get the member number passed in
    my $mem = shift;

    #Send the print function the entry for that member
    print_visitor($HashOfNums{$mem});

    print "<br><a href = delete.cgi>Back to Registry List</a>";
		
}

#this function prints the smaller version of the entries
sub print_small{
    my $entry = shift;

    #split the information in the entry
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $entry);

    #correct the homepage syntax (adds http:// if necessary)
    $link = $homepage;
    $link="http://".$link  unless $link =~ /\/\/|none|empty/gi;

    #this large print statement prints the information of the given user (entry)
    if($homepage eq "none" || $homepage eq "empty"|| $homepage eq ""){
	print "<tr><td>$last_name, $first_name</td>";
    }
    else{
	print "<tr><td><a href=$link>$last_name, $first_name</a></td>";
    }
    print "<td>$country</td>";
    

    $last_name =~ s/ /_/g;
    $first_name =~ s/ /_/g;
    print qq'
        <td>[<a href= "delete.cgi?function=print&member=$num">Full Entry</a>] 
	<a href= "delete.cgi?function=delete&member=$num">Delete Entry</a> </td></tr>
';
}


#this function will print all the entries
sub printall{
    print "<table border = 2><tr bgcolor = \"ffff00\"><td>Name</td><td>Country of Residence</td><td>Options</td></tr>";
    foreach $name (sort keys %HashOfArrays){
	foreach (@{$HashOfArrays{$name}}) {
	    print_small($_);
	}
    }

    print "</table><br><a href= approve.cgi>Back to Approve</a>";
}


#This function is used to print out a visitor's information if a search gets results
sub print_visitor{
    my $entry = shift;

    #split the information in $entry
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $entry);

    #correct the homepage syntax (adds http:// if necessary)
    if($homepage ne ""){
	$link = $homepage;
	$link="http://".$link  unless $link =~ /\/\/|none|empty/gi;
    }
    if($homepage2 ne ""){
	$link2 = $homepage2;
	$link2="http://".$link2  unless $link2 =~ /\/\/|none|empty/gi;
    }


    #this large print statement prints the information of the given user ($entry)
    print <<EndHTML;
    <table border = 10 noshade>
      <tr bgcolor = "ffff00"><td>
      Name:
	</td><td>$last_name, $first_name
	</td></tr>
	<tr><td>
      Job title/position::
	</td><td>
EndHTML
if($status =~ /^Student/){
    ($temp1, $temp2, $temp3) = split (/%%%/,$status);
     print "Student</td></tr><tr><td>Student Advisor/Supervisor:</td><td>$temp2</td></tr><tr><td>";
     print "Advisor/Supervisor's Email:</td><td><a href = mailto:$temp3>$temp3</a></td></tr>";
 }
     else{
	 $status =~ s/%%%/:/g;
	 print "$status </td></tr>";
     }
     print <<EndHTML;
	<tr><td>
	Organization:  
	</td><td>$affiliation
	</td></tr>
	<tr><td>
	Department:  
	</td><td>$department
	</td></tr>
	<tr><td>
	Address line 1:
	</td><td>$address
	</td></tr>
	<tr><td>
	Address line 2:
	</td><td>
EndHTML
if($address2 eq ""){
    print "none";
}
    else{
	print "$address2";
    }
    print <<EndHTML;
	</td></tr>
	<tr><td>
	City:
	</td><td>$city
	</td></tr>
	<tr><td>
	State/Province:
	</td><td>$state
	</td></tr>
	<tr><td>
        Postal Code:
	</td><td>$postal_code
	</td></tr>
	<tr><td>
	Country of Residence: 
	</td><td>$country
	</td></tr>
	<tr><td>
EndHTML
	
#prints the homepage and email as a link, unless "none" or "empty" were given
if($homepage eq ""){
    print "Personal Homepage: </td><td>none</td></tr><tr><td>";
}
    else{
	print "Personal Homepage:</td><td>  <a href=$link>$link</a></td></tr><tr><td>";
    }

    if($homepage2 eq ""){
	print "Departmental/Group Homepage: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Departmental/Group Homepage: </td><td> <a href=$link2>$link2</a></td></tr><tr><td>";
    }

    if($email eq "none" || $email eq "empty"){
	print "Email: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Email:</td><td>  <a href = mailto:$email>$email</a></td></tr><tr><td>";
    }

    if($email2 eq "none" || $email2 eq "empty" || $email2 eq ""){
	print "Alternate Email: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Alternate Email:</td><td>  <a href = mailto:$email2>$email2</a></td></tr><tr><td>";
    }
    $last_name =~ s/ /_/g;
    $first_name =~ s/ /_/g;

    #prints the end of the data (research interests and origin country)
    print <<EndHTML;
    Research Interests:
    </td><td> $research
	</td></tr>
	<tr><td>
	Country of Origin:
	</td><td>$origin_country</td></tr></table>
	<i>Last updated: $date</i><br>
	<a href= "delete.cgi?function=delete&member=$num">Delete Entry</a><br><br>
	
EndHTML
}


sub delete_entry{
    my $member = shift;

    #print the info to the deleted entries file (deleted.txt)
    open(FP2,">>deleted.txt") or dienice("Couldn't open deleted.txt: $! \n");
    
    #lock the file in case of multiple users
    flock(FP2,2);
    
    #move to the beginning of the file
    seek(FP2,0,2);
    
    #print the member to deleted.txt to keep on hand for possible re-addition to the registry
    print FP2 "$HashOfNums{$member}\n";

    #close file
    close(FP2);
 
    #split the information of the deleted entry ($HashOfNums{$member})
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $HashOfNums{$member});
   

    #open the registry (registry.txt)
    open(FP2,"../approvedadd/registry.txt") or dienice("Couldn't open registry.txt: $! \n");
    
    #lock the file in case of multiple users
    flock(FP2,2);
    
    #move to the beginning of the file
    seek(FP2,0,0);


    
    #look for the entry to delete, save the registry except the deleted one
    $temp = <FP2>;
    #while the member numbers are different, save the entry in @beginning
    while(($temp !~ /^$num\|/)){
	push @beginning,$temp;
	$temp = <FP2>;
    }
    #save the rest in @end.  The file to delete is in $temp after this loop terminates
    @end = <FP2>;
    
    #close file
    close(FP2);


    #Open registry.txt to save the registry info, without the deleted entry
    open(FP3,">../approvedadd/registry.txt") or dienice("Couldn't open registry.txt: $! \n");

    #lock the file, and move to the beginning
    flock(FP3,2);
    seek(FP3,0,0);
    
    #print @beginning and @end back to registry.txt, removing the deleted entry stored in $temp
    print FP3 @beginning,@end;
    
    #close the registry
    close(FP3);
    
    #print a notice to the administrator that the entry has been deleted
    print "The entry for <font size=5 color= \"ff0000\">$last_name, $first_name</font> has been deleted.<br>";

    print "<br><a href = delete.cgi>Back to Registry List</a>";


}
#function will print an error message on the html page
sub dienice{
    my($msg) = @_;
    print "<h2Error</h2>\n";
    print $msg;
    exit;
}
