#!/usr/bin/perl

# undelete.cgi
#
# This is a cgi that will allow a administrator to 
# Re-add a deleted entry to the registry
#
# Copyright (C) 2002
# Ted Pedersen, University of Minnesota, Duluth
# tpederse@d.umn.edu
# Brian Rassier, University of Minnesota, Duluth
# rass0028@d.umn.edu
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#-----------------------------------------------------------------------------
#                              Start of program
#-----------------------------------------------------------------------------

use CGI;

#make a new cgi object
$cgi = new CGI();

#print the header for the cgi
print $cgi->header();

#print the top portion of the root html page
print <<EndHTML;
<html><head><title>Re-add a Deleted Entry</title></head>
    <body BGCOLOR = "ffffff">
    <h2 align ="CENTER">Re-add a Deleted Entry</h2>
<hr size=5 noshade><br>
EndHTML

#finds the query string if a user selects a 
#letter link to find names beginning with that letter
if($ENV{'QUERY_STRING'}){
    #split the '&' in the query string
    @values = split(/&/,$ENV{'QUERY_STRING'});
    #split the = to find the letter
    foreach $i (@values){
	($varname, $mydata) = split(/=/,$i);
	$in{$varname} = $mydata;
    }
}
else{
    #if no querystring, undefine the querystring hash
    undef(%in);
}

#save the letter/member that was pressed
$member = $in{'member'};

#open deleted.txt to check for possible entries to re-add
open(INFP,"deleted.txt") or dienice("Couldn't open deleted.txt: $! \n");

#lock the file in case of multiple users
flock(INFP,2);

#move to the beginning of the file
seek(INFP,0,0);

#store the data in @data
@data = <INFP>;

#close file
close(INFP);

#if data is found
if(@data){
    #go through each line of data
    foreach $i (@data){
	#remove newline
	chomp($i);

	#split the information in $i
	($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date) = split(/\|/, $i);

	#store the file based on last name into the HashOfArrays.
	#HashOfArrays is a hash of the people based on last name.
	#This takes care of the issue of two people having the same last name.
	if($HashOfArrays{$last_name}){
	    my @temp = @{$HashOfArrays{$last_name}};
	    push @temp,$i;
	    $HashOfArrays{$last_name} = \@temp;
	}
	else{
	    my @temp = ();
	    push @temp, $i;
	    $HashOfArrays{$last_name} = \@temp;
	}
	#make another hash, based on member numbers
	$HashOfNums{$num} = $i;

	#remove underscores from the values
	$country =~ s/_/ /g;
	$origin_country =~ s/_/ /g;
	
    }
}
#if there was no data, print a note to state this
else{
    print "<b>No Entries to Re-add</b><br>"
    }

#if there is a member coming in from the query string
if($member){
    #if full entry was pressed, find the entry and print it
    if($in{'function'} eq "print"){
	findentry($in{'member'});
    }
    #if undelete was pressed, call undelete_entry to re-add
    elsif($in{'function'} eq "undelete"){
	undelete_entry($in{'member'});
    }
}

#if there is info in @data, print all the entries using printall()
else{ 
    if(@data){ 
	print "<a href= approve.cgi>Back to Approve</a><br><br>";
	printall();
    } #print all names to re-add, unless no names to re-add
    else{
	print "</table><br><a href= approve.cgi>Back to Approve</a>";
    } #else print the back link
	
}
#print the ending html tag
print "</html>";


#this function finds the entry that matches last name, first name, and email, and prints the full entry
sub findentry{
    #get the member number passed in
    my $mem = shift;

    #Send the print function the entry for that member
    print_visitor($HashOfNums{$mem});

    #print a back link
    print "<br><a href = undelete.cgi>Back to Registry List</a>";
		
}

#this function prints the smaller version of the entries
sub print_small{
    my $entry = shift;

    #split the information in $entry
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $entry);

    #correct the homepage syntax (adds http:// if necessary)
    $link = $homepage;
    $link="http://".$link  unless $link =~ /\/\/|none|empty/gi;

    #this large print statement prints the information of the given user ($entry)
    if($homepage eq "none" || $homepage eq "empty"|| $homepage eq ""){
	print "<tr><td>$last_name, $first_name</td>";
    }
    else{
	print "<tr><td><a href=$link>$last_name, $first_name</a></td>";
    }
    print "<td>$country</td>";
    
    #change spaces to underscores in names
    $last_name =~ s/ /_/g;
    $first_name =~ s/ /_/g;

    #print the options for each entry
    print qq'
        <td>[<a href= "undelete.cgi?function=print&member=$num">Full Entry</a>] 
	<a href= "undelete.cgi?function=undelete&member=$num">Re-add Entry</a> </td></tr>
';
}


#this function will print all the entries
sub printall{
    print "<table border = 2><tr bgcolor = \"ffff00\"><td>Name</td><td>Country of Residence</td><td>Options</td></tr>";

    #for each element in the hash of arrays of names, print the small version of their respective entries
    foreach $name (sort keys %HashOfArrays){
	foreach (@{$HashOfArrays{$name}}) {
	    print_small($_);
	}
    }

    #print the back link
    print "</table><br><a href= approve.cgi>Back to Approve</a>";
}


#This function is used to print out a visitor's information if a search gets results
sub print_visitor{
    my $entry = shift;

    #split the information in $entry
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $entry);

    #correct the homepage syntax (adds http:// if necessary)
    if($homepage ne ""){
	$link = $homepage;
	$link="http://".$link  unless $link =~ /\/\/|none|empty/gi;
    }
    if($homepage2 ne ""){
	$link2 = $homepage2;
	$link2="http://".$link2  unless $link2 =~ /\/\/|none|empty/gi;
    }


    #this large print statement prints the information of the given user ($entry)
    print <<EndHTML;
    <table border = 10 noshade>
      <tr bgcolor = "ffff00"><td>
      Name:
	</td><td>$last_name, $first_name
	</td></tr>
	<tr><td>
      Job title/position::
	</td><td>
EndHTML
if($status =~ /^Student/){
    ($temp1, $temp2, $temp3) = split (/%%%/,$status);
     print "Student</td></tr><tr><td>Student Advisor/Supervisor:</td><td>$temp2</td></tr><tr><td>";
     print "Advisor/Supervisor's Email:</td><td><a href = mailto:$temp3>$temp3</a></td></tr>";
 }
     else{
	 $status =~ s/%%%/:/g;
	 print "$status </td></tr>";
     }
     print <<EndHTML;
	<tr><td>
	Organization:  
	</td><td>$affiliation
	</td></tr>
	<tr><td>
	Department:  
	</td><td>$department
	</td></tr>
	<tr><td>
	Address line 1:
	</td><td>$address
	</td></tr>
	<tr><td>
	Address line 2:
	</td><td>
EndHTML
if($address2 eq ""){
    print "none";
}
    else{
	print "$address2";
    }
    print <<EndHTML;
	</td></tr>
	<tr><td>
	City:
	</td><td>$city
	</td></tr>
	<tr><td>
	State/Province:
	</td><td>$state
	</td></tr>
	<tr><td>
        Postal Code:
	</td><td>$postal_code
	</td></tr>
	<tr><td>
	Country of Residence: 
	</td><td>$country
	</td></tr>
	<tr><td>
EndHTML
	
#prints the homepage and email as a link, unless "none" or "empty" were given
if($homepage eq ""){
    print "Personal Homepage: </td><td>none</td></tr><tr><td>";
}
    else{
	print "Personal Homepage:</td><td>  <a href=$link>$link</a></td></tr><tr><td>";
    }

    if($homepage2 eq ""){
	print "Departmental/Group Homepage: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Departmental/Group Homepage: </td><td> <a href=$link2>$link2</a></td></tr><tr><td>";
    }

    if($email eq "none" || $email eq "empty"){
	print "Email: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Email:</td><td>  <a href = mailto:$email>$email</a></td></tr><tr><td>";
    }

    if($email2 eq "none" || $email2 eq "empty" || $email2 eq ""){
	print "Alternate Email: </td><td>none</td></tr><tr><td>";
    }
    else{
	print "Alternate Email:</td><td>  <a href = mailto:$email2>$email2</a></td></tr><tr><td>";
    }
    $last_name =~ s/ /_/g;
    $first_name =~ s/ /_/g;

    #prints the end of the data (research interests and origin country)
    print <<EndHTML;
    Research Interests:
    </td><td> $research
	</td></tr>
	<tr><td>
	Country of Origin:
	</td><td>$origin_country</td></tr></table>
	<i>Last updated: $date</i><br>
	<a href= "undelete.cgi?function=undelete&member=$num">Re-add Entry</a><br><br>
	
EndHTML
}

#This is the main functionality of undelete.cgi. It re-adds the entry that is passed in to registry.txt, 
#and removes it from the deleted list.  
sub undelete_entry{
    my $member = shift;

    #split the information
    ($num,$status, $last_name, $first_name, $affiliation, $department, $address, $address2, $city, $state, $postal_code,$country, $homepage, $homepage2, $email, $email2, $research, $origin_country,$date,$location) = split(/\|/, $HashOfNums{$member});



    #remove the info from the deleted entries file, deleted.txt
    open(FP,"deleted.txt") or dienice("Couldn't open deleted.txt: $! \n");

    #lock the file in case of multiple users
    flock(FP,2);

    #move to the beginning of the file
    seek(FP,0,0);
    
    #look for the entry to delete, save the registry except the deleted one
    $temp = <FP>;

    #while the member number doesn't match the one to re-add, save the entries in @beginning
    while($temp !~ /^$num\|/){
	push @beginning,$temp;
	$temp = <FP>;
    }

    #save the rest of the file in @end.  $temp now stores the file to remove from deleted.txt
    @end = <FP>;
    
    #close file
    close(FP);

    #Open deleted.txt to save the file info, without the deleted entry
    open(FP3,">deleted.txt") or dienice("Couldn't open deleted.txt: $! \n");

    #lock the file, and seek to the beginning of it
    flock(FP3,2);
    seek(FP3,0,0);
    
    #print the beginning and the end of the file, leaving out $temp which holds the entry to 
    # be deleted.
    print FP3 @beginning,@end;
    
    #close deleted.txt
    close(FP3);

    #open the registry
    open(FP2,"../approvedadd/registry.txt") or dienice("Couldn't open registry.txt: $! \n");
    
    #lock the file in case of multiple users
    flock(FP2,2);
    
    #move to the beginning of the file
    seek(FP2,0,0);


    
    #This portion re-adds the deleted entry to the registry, while maintaining
    #the member order of the registry.

    #look for the entry to delete, save the registry except the deleted one
    $temp = <FP2>;
    $tempnum = $temp; #copy temp into tempnum
    $tempnum =~ s/^([0-9]+)/$1/; #get the member number from beginning of entry
    undef (@beginning); #clear out beginning from earlier use

    while(($tempnum < $num)){ #while the member number is less than the to-add member
	push @beginning,$temp; #save the $temp in @beginning
	$temp = <FP2>; #get the next entry
	if(eof FP2){ #if the next entry is the last, consider the special case
	    $tempnum = $temp; #copy temp into tempnum
	    $tempnum =~ s/^([0-9]+)/$1/; ##get the member number from the beginning of the entry
	    if($tempnum < $num){ #if the entry number is less than the one to add to the registry, save it
		push @beginning, $temp; #save the entry in @beginning because its member number < the one to add
		$temp = ""; #make $temp = "", so when it is printed to the file, it doesn't mess anything up
	    }
	    
	    last; #exit the loop
	}
	$tempnum = $temp; #copy temp into tempnum
	$tempnum =~ s/^([0-9]+)/$1/; #get the member number from beginning of entry
    }

    #save the end of the file into @end
    @end = <FP2>;
    
    #close file
    close(FP2);


    #Open registry.txt to save the registry info, without the re-added entry incorporated
    open(FP3,">../approvedadd/registry.txt") or dienice("Couldn't open registry.txt: $! \n");

    #lock registry.txt, and seek to the beginning of it
    flock(FP3,2);
    seek(FP3,0,0);
    
    #print @beginning which is the beginning of the file up to the re-added entry
    #print $HashOfNums{$member} which is the re-added entry
    #print \n after $HashOfNums{$member}
    #print temp, which could be the entry after the re-added entry, or "" depending on the numbering situation
    #print @end which is the end of the file, after the re-added entry
    print FP3 @beginning,$HashOfNums{$member},"\n",$temp,@end;
    
    #close registry.txt
    close(FP3);
    

    #print a notice to the administrator telling them that the entry was re-added.
    print "The entry for <font size=5 color= \"ff0000\">$last_name, $first_name</font> has been re-added.<br>";

    print "<br><a href = undelete.cgi>Back to Deleted List</a>";

}

#function will print an error message
sub dienice{
    my($msg) = @_;
    print "<h2Error</h2>\n";
    print $msg;
    exit;
}
